#ifndef SOLIDSTATEPHYSICS_UNITSYSTEM_MASSUNIT_H
#define SOLIDSTATEPHYSICS_UNITSYSTEM_MASSUNIT_H

#include <ratio>


namespace SolidStatePhysics
{
	namespace UnitSystem
	{
		namespace MassUnit
		{
			struct AtomicUnit
			{
				static constexpr double unitMassInSI() noexcept;
			};

			template <typename Magnitude = std::ratio<1>>
			struct Gram
			{
				static constexpr double unitMassInSI() noexcept;
			};
		}
	}
}

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constant expressions

inline constexpr double SolidStatePhysics::UnitSystem::MassUnit::AtomicUnit::unitMassInSI() noexcept
{
	return (0.91093837015 / (static_cast<double>(std::peta::num) * static_cast<double>(std::peta::num)));
}

template <typename Magnitude>
inline constexpr double SolidStatePhysics::UnitSystem::MassUnit::Gram<Magnitude>::unitMassInSI() noexcept
{
	return (static_cast<double>(Magnitude::num) / static_cast<double>(Magnitude::den));
}

// Constant expressions
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************

#endif // !SOLIDSTATEPHYSICS_UNITSYSTEM_MASSUNIT_H
