#ifndef SOLIDSTATEPHYSICS_UNITSYSTEM_PRESSUREUNIT_H
#define SOLIDSTATEPHYSICS_UNITSYSTEM_PRESSUREUNIT_H

#include <ratio>


namespace SolidStatePhysics
{
	namespace UnitSystem
	{
		namespace PressureUnit
		{
			template <typename Magnitude = std::ratio<1>>
			struct Pascal
			{
				static constexpr double unitPressureInSI() noexcept;
			};
		}
	}
}

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constant expressions

template <typename Magnitude>
inline constexpr double SolidStatePhysics::UnitSystem::PressureUnit::Pascal<Magnitude>::unitPressureInSI() noexcept
{
	return (static_cast<double>(Magnitude::num) / static_cast<double>(Magnitude::den));
}

// Constant expressions
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************

#endif // !SOLIDSTATEPHYSICS_UNITSYSTEM_PRESSUREUNIT_H
