#ifndef SOLIDSTATEPHYSICS_UNITSYSTEM_VELOCITYUNIT_H
#define SOLIDSTATEPHYSICS_UNITSYSTEM_VELOCITYUNIT_H

#include <ratio>


namespace SolidStatePhysics
{
	namespace UnitSystem
	{
		namespace VelocityUnit
		{
			struct AtomicUnit
			{
				static constexpr double unitVelocityInSI() noexcept;
			};

			struct MetrePerSecond
			{
				static constexpr double unitVelocityInSI() noexcept;
			};
		}
	}
}

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constant expressions

inline constexpr double SolidStatePhysics::UnitSystem::VelocityUnit::AtomicUnit::unitVelocityInSI() noexcept
{
	return (2.18769126364 * static_cast<double>(std::mega::num));
}

inline constexpr double SolidStatePhysics::UnitSystem::VelocityUnit::MetrePerSecond::unitVelocityInSI() noexcept
{
	return 1.0;
}

// Constant expressions
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************

#endif // !SOLIDSTATEPHYSICS_UNITSYSTEM_VELOCITYUNIT_H
