#include "Clock.h"

#include <iomanip>
#include <sstream>
#include <ctime>

using namespace ControlCenter::System;

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructor

Clock::Clock()
	: m_stopWatch{ std::chrono::system_clock::now() }
{
}

// Constructor
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Static methods

std::string Clock::tellElapsedTime()
{
	if (m_isRunningStopWatch)
	{
		std::string elapsedTimeString;
		{
			std::chrono::seconds elapsedSeconds = std::chrono::duration_cast<std::chrono::seconds>(std::chrono::system_clock::now().time_since_epoch() - m_stopWatch.time_since_epoch());

			auto days = elapsedSeconds.count() / 86400;
			elapsedSeconds -= std::chrono::seconds{ (86400 * days) };
			{
				if (days != 0)
				{
					elapsedTimeString += std::to_string(days);
					elapsedTimeString += " days ";
				}
			}
			auto hours = elapsedSeconds.count() / 3600;
			elapsedSeconds -= std::chrono::seconds{ (3600 * hours) };
			{
				if (hours != 0)
				{
					elapsedTimeString += std::to_string(hours);
					elapsedTimeString += " hours ";
				}
			}
			auto minutes = elapsedSeconds.count() / 60;
			elapsedSeconds -= std::chrono::seconds{ (60 * minutes) };
			{
				if (minutes != 0)
				{
					elapsedTimeString += std::to_string(minutes);
					elapsedTimeString += " minutes ";
				}
			}
			auto seconds = elapsedSeconds.count() % 60;
			{
				elapsedTimeString += std::to_string(seconds);
				elapsedTimeString += " seconds";
			}
		}

		std::stringstream elapsedTimeStream;
		elapsedTimeStream << elapsedTimeString << std::endl;
		return elapsedTimeStream.str();
	}

	else
	{
		std::string errorMessage = "------------------------------------------------------\n\n";
		errorMessage += "Error   : Invalid argument\n";
		errorMessage += "Location: The member function of \"tellElapsedTime\" in the class of ControlCenter::Administering::Clock.\n";
		errorMessage += "Message : The stopwatch is not running.\n\n";
		errorMessage += "------------------------------------------------------\n\n";
		throw std::invalid_argument(errorMessage);
	}
}

std::string Clock::tellNowTime()
{
	std::time_t nowTime = std::chrono::system_clock::to_time_t(std::chrono::system_clock::now());
	
	std::stringstream localTimeStream;
	localTimeStream << std::put_time(std::localtime(&nowTime), "%c");
	return localTimeStream.str();
}

// Static methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
