#include "MinMaxConstrainter.h"

using namespace SolidStatePhysics::Crystallization::Calculators;

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Protected constructors

double MinMaxConstrainter::m_attractiveForceConstant{ 30.0 };
double MinMaxConstrainter::m_repulsiveForceConstant{ -100.0 };


MinMaxConstrainter::MinMaxConstrainter(InteractingAtom& ownerAtom, AtomicAdaptor&& attachedAtom)
	: InteratomicConnector{ ownerAtom, std::move(attachedAtom) }
	, m_minimumDistance{ 0.0 }
	, m_maximumDistance{ 0.0 }
{
}

MinMaxConstrainter::MinMaxConstrainter(const std::shared_ptr<MinMaxConstrainter>& twinPtr)
	: InteratomicConnector{ std::static_pointer_cast<InteratomicConnector>(twinPtr) }
	, m_minimumDistance{ 0.0 }
	, m_maximumDistance{ 0.0 }
{
}

// Protected constructors
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
