#include "MinimumConstrainter.h"

using namespace SolidStatePhysics::Crystallization::Calculators;

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Protected constructors

double MinimumConstrainter::m_repulsiveForceConstant{ -100.0 };


MinimumConstrainter::MinimumConstrainter(InteractingAtom& ownerAtom, AtomicAdaptor&& attachedAtom)
	: InteratomicConnector{ ownerAtom, std::move(attachedAtom) }
	, m_minimumDistance{ 0.0 }
{
}

MinimumConstrainter::MinimumConstrainter(const std::shared_ptr<MinimumConstrainter>& twinPtr)
	: InteratomicConnector{ std::static_pointer_cast<InteratomicConnector>(twinPtr) }
	, m_minimumDistance{ twinPtr->m_minimumDistance }
{
}

// Protected constructors
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
